
#include "pirat.h"
#include "piratutil.h"


/*
  Function to be called in case an error occurred in the library.
  It can be also used by the application writer.
 */
int
pirat_error(char *file, int line, int kind, char *explanation)
{
  char buf[1024];

  switch (kind) {
  case PIRAT_FATAL_ERROR:
    sprintf(buf, "Fatal error (%s, line %d):\n %s\n", file, line, explanation);
    fprintf(stderr, "%s\n", buf);
    exit(EXIT_FAILURE);
    break;
  case PIRAT_ERROR:
    sprintf(buf, "Error (%s, line %d):\n %s\n", file, line, explanation);
    fprintf(stderr, "%s\n", buf);
    exit(EXIT_FAILURE);
    break;
  case PIRAT_WARNING:
    sprintf(buf, "Warning (%s, line %d):\n %s\n", file, line, explanation);
    fprintf(stderr, "%s\n", buf);
    break;
  }
  return 1;
}


void
pirat_assert_failed(char *expr, char *file, int line)
{
  char buf[1280];
  
  sprintf(buf, "Failed assert %s (%s, %d)\n", expr, file, line);
  fprintf(stderr, "%s\n", buf);
  while (1) {
    buf[0] = buf[0];
  }
}
